package de.fraunhofer.sit.c2x.pki.ca.provider.interfaces;

import de.fraunhofer.sit.c2x.pki.ca.provider.ProviderException;
import de.fraunhofer.sit.c2x.pki.ca.provider.entities.IssuedCertificateInfo;
import de.fraunhofer.sit.c2x.pki.ca.provider.entities.IssuedCertificateInfoLink;

/**
 * @author Daniel Quanz (daniel.quanz@sit.fraunhofer.de)
 */
public interface IssuedCertsWithIdkInfoProvider extends
		IssuedCertsInfoProvider<IssuedCertificateInfo> {

	public abstract IssuedCertificateInfoLink[] getCerts(byte[] canonicalId, int offset, int limit)
			throws ProviderException;
	
	public abstract byte[] getIdk(byte[] certId) throws ProviderException;

	public abstract void save(IssuedCertificateInfo info, byte[] idk)
			throws ProviderException;

}
